//********************************************************************
//  Init.java       Author: Ryo (Rio) Akasaka
//  
//  Last modified: Mon Feb 25, 2007
//
//  This class contains all the information pertaining to the initials
//  its rank with respect to the accumulated sum of all the frequencies
//  of the names that share the same initial, as well as the frequenc-
//  ies.
//********************************************************************

public class Init implements Comparable {
  
  private String firstname;
  private Character character;
  private Integer frequency, total, rank, initrank;

  public Init () {
    total = 0;
    rank = 0;
  }  
  
  //-----------------------------------------------------------------
  //  Mutators
  //-----------------------------------------------------------------
  // Set rank
  public void setRank(int num) { rank = num; }

  // Adds particular letter of alphabet
  public void addInitials(Character c) { character = c; }

  // Adds frequency number for particular letter of the alphabet
  public void addNum(int num) { total += num; }

  //-----------------------------------------------------------------
  //  Accessors
  //-----------------------------------------------------------------

  // Get rank of frequency-based sort
  public int getRank() { return rank; }

  // Get initial 
  public char getInitials() { return firstname.charAt(0); }

  // Get rank of initial
  public int getInitRank() { return initrank; }

  //-----------------------------------------------------------------
  //  Sorting and compareTo
  //-----------------------------------------------------------------
  // Allows comparison of character
  public Character retrieveInitials() { return character; }

  // Allows comparison of total frequencies for particular letter
  public Integer getTotal() { return total; }

  // Allows comparison of name
  public int compareTo(Object other) { 
      return firstname.compareTo(((Line) other).getName());
  }
  public String toString() {
    String result = "";
    result += frequency;
    return result;
  }
}