//********************************************************************
//  Init.java       Author: Ryo (Rio) Akasaka
//  
//  Last modified: Mon Feb 25, 2007
//
//  This class contains all the information pertaining to the frequency,
//  rank, and/or name
//********************************************************************

public class Line implements Comparable {
  
  private String firstname;
  private Character character;
  private Integer frequency, total, rank;
  
  public Line (String name, int num) {
    firstname = name;
    frequency = num;
    rank = 0;
    total = 0;
  }  

  //-----------------------------------------------------------------
  //  Mutators
  //-----------------------------------------------------------------
  // Set rank
  public void setRank(int num) { rank = num; }

  // Adds frequency number for particular letter of the alphabet
  public void addNum(int num) { total += num; }

  //-----------------------------------------------------------------
  //  Accessors
  //-----------------------------------------------------------------
  // Get name 
  public String getName() { return firstname; }

  // Get frequency
  public Integer getNum() { return frequency; }

  // Get rank of frequency-based sort
  public int getRank() { return rank; }

  // Get initial 
  public char getInitials() { return firstname.charAt(0); }

  //-----------------------------------------------------------------
  //  Sorting and compareTo
  //-----------------------------------------------------------------

  // Allows comparison of name
  public int compareTo(Object other) { 
      return firstname.compareTo(((Line) other).getName());
  }
  public String toString() {
    String result = "";
    result += frequency;
    return result;
  }
}